/* Uniform area */
uniform sampler2D screenTexture;

/* Output color */
out vec4 color;

vec3 reinhard(vec3 c)
{
    c = c * 2;
    return c / (c + vec3(1.0));
}

vec3 exposure(const vec3 c, const float e)
{
    return vec3(1.0) - exp(-c * e);
}

vec3 aces(const vec3 x)
{
    const float a = 2.51;
    const float b = 0.03;
    const float c = 2.43;
    const float d = 0.59;
    const float e = 0.14;
    return clamp((x * (a * x + b)) / (x * (c * x + d ) + e), 0.0, 1.0);
}

void main(void)
{
    vec4 screenColor = texture(screenTexture, viewSpaceTexcoord);
    color = vec4(aces(screenColor.rgb), 1);
}